/* Fichier: gtlglw_ui.c
 *
 * Gestion de l'affichage OpenGL pour l'interface Gtk+-2.x
 * S'occupe de crer la fenetre de rendu et d'y associer 
 * les callbacks classiques pour le redimensionnement etc...
 * Ces callbacks se trouvent dans le fichier gtkglw_cb.c 
 */

#include "projet.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)


GtkWidget *
create_gl_window (void)
{
  GtkWidget *render_window;
  GtkWidget *renderw_hbox;
  GtkWidget *renderw_menubar;
  GtkWidget *menuitem1;
  
  GtkWidget *menu1;
  GtkWidget *nouveau1;
  GtkWidget *ouvrir1;
  GtkWidget *enregistrer1;
  GtkWidget *enregistrer_sous1;
  GtkWidget *exporter1;
  GtkWidget *image73;
  GtkWidget *separatormenuitem1;
  GtkWidget *quitter1;
 
  GtkWidget *menuitem3;
  GtkWidget *menu3;
  GtkWidget *filtres1;
  GtkWidget *image74;
  GtkWidget *image75;
  
  GtkWidget *backfaceculling1;
  GtkWidget *wireframe1;
  
  GtkWidget *menuitem4;
  GtkWidget *menu4;
  GtkWidget *about1;
  
  GtkWidget *menuitem3_menu;
  GtkWidget *controles1;
  GtkWidget *controles1_menu;
  GSList *terrain1_group = NULL;
  GtkWidget *terrain1;
  GtkWidget *camera1;
  
  GtkWidget *renderw_toolbar;
  GtkWidget *renderw_newb;
  GtkWidget *renderw_openb;
  GtkWidget *renderw_saveb;
  GtkWidget *renderw_refrb;
  GtkWidget *renderw_filtersb;
  GtkWidget *renderw_statbar;
  GtkAccelGroup *accel_group;

  GdkGLConfig *glconfig;
  GtkWidget *drawing_area;

  /* on prepare gtk  recevoir de l'OpenGL */
  /* essayons d'activer le double buffering */
  glconfig = gdk_gl_config_new_by_mode (GDK_GL_MODE_RGB |
					GDK_GL_MODE_DEPTH |
					GDK_GL_MODE_DOUBLE);
  if (glconfig == NULL) {
    g_print ("*** Cannot find the double-buffered visual.\n");
    g_print ("*** Trying single-buffered visual.\n");

    /* on se rabat sur le single buffer */
    glconfig = gdk_gl_config_new_by_mode (GDK_GL_MODE_RGB |
					  GDK_GL_MODE_DEPTH);
    if (glconfig == NULL) {
      g_print ("*** No appropriate OpenGL-capable visual found.\n");
      exit (1);
    }
  }

  accel_group = gtk_accel_group_new ();

  render_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (render_window), _("Vue du terrain"));

  renderw_hbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (renderw_hbox);
  gtk_container_add (GTK_CONTAINER (render_window), renderw_hbox);

  renderw_menubar = gtk_menu_bar_new ();
  gtk_widget_show (renderw_menubar);
  gtk_box_pack_start (GTK_BOX (renderw_hbox), renderw_menubar, FALSE, FALSE,
		      0);

  menuitem1 = gtk_menu_item_new_with_mnemonic (_("_Fichier"));
  gtk_widget_show (menuitem1);
  gtk_container_add (GTK_CONTAINER (renderw_menubar), menuitem1);

  menu1 = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem1), menu1);

  nouveau1 = gtk_image_menu_item_new_from_stock ("gtk-new", accel_group);
  gtk_widget_show (nouveau1);
  gtk_container_add (GTK_CONTAINER (menu1), nouveau1);

  ouvrir1 = gtk_image_menu_item_new_from_stock ("gtk-open", accel_group);
  gtk_widget_show (ouvrir1);
  gtk_container_add (GTK_CONTAINER (menu1), ouvrir1);

  enregistrer1 = gtk_image_menu_item_new_from_stock ("gtk-save", accel_group);
  gtk_widget_show (enregistrer1);
  gtk_container_add (GTK_CONTAINER (menu1), enregistrer1);

  enregistrer_sous1 =
    gtk_image_menu_item_new_from_stock ("gtk-save-as", accel_group);
  gtk_widget_show (enregistrer_sous1);
  gtk_container_add (GTK_CONTAINER (menu1), enregistrer_sous1);
  
  exporter1 = gtk_image_menu_item_new_with_mnemonic (_("_Exporter (PNG)"));
  gtk_widget_show (exporter1);
  gtk_container_add (GTK_CONTAINER (menu1), exporter1);
  image73 = gtk_image_new_from_stock ("gtk-redo", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image73);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (exporter1), image73);

  separatormenuitem1 = gtk_separator_menu_item_new ();
  gtk_widget_show (separatormenuitem1);
  gtk_container_add (GTK_CONTAINER (menu1), separatormenuitem1);
  gtk_widget_set_sensitive (separatormenuitem1, FALSE);

  quitter1 = gtk_image_menu_item_new_from_stock ("gtk-quit", accel_group);
  gtk_widget_show (quitter1);
  gtk_container_add (GTK_CONTAINER (menu1), quitter1);

  menuitem3 = gtk_menu_item_new_with_mnemonic (_("_Vue"));
  gtk_widget_show (menuitem3);
  gtk_container_add (GTK_CONTAINER (renderw_menubar), menuitem3);

  menu3 = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem3), menu3);
  
  menuitem3_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem3), menuitem3_menu);
  
  filtres1 = gtk_image_menu_item_new_with_mnemonic (_("_Filtres..."));
  gtk_widget_show (filtres1);
  gtk_container_add (GTK_CONTAINER (menuitem3_menu), filtres1);
  image74 = gtk_image_new_from_stock ("gtk-convert", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image74);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (filtres1), image74);
  
  backfaceculling1 = gtk_check_menu_item_new_with_mnemonic (_("Backface culling"));
  gtk_widget_show (backfaceculling1);
  gtk_container_add (GTK_CONTAINER (menuitem3_menu), backfaceculling1);
  
  wireframe1 = gtk_check_menu_item_new_with_mnemonic (_("Fil de fer"));
  gtk_widget_show (wireframe1);
  gtk_container_add (GTK_CONTAINER (menuitem3_menu), wireframe1);

  controles1 = gtk_menu_item_new_with_mnemonic (_("Controles"));
  gtk_widget_show (controles1);
  gtk_container_add (GTK_CONTAINER (menuitem3_menu), controles1);

  controles1_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (controles1), controles1_menu);

  terrain1 = gtk_radio_menu_item_new_with_mnemonic (terrain1_group, _("terrain"));
  terrain1_group = gtk_radio_menu_item_get_group (GTK_RADIO_MENU_ITEM (terrain1));
  gtk_widget_show (terrain1);
  gtk_container_add (GTK_CONTAINER (controles1_menu), terrain1);

  camera1 = gtk_radio_menu_item_new_with_mnemonic (terrain1_group, _("camera"));
  terrain1_group = gtk_radio_menu_item_get_group (GTK_RADIO_MENU_ITEM (camera1));
  gtk_widget_show (camera1);
  gtk_container_add (GTK_CONTAINER (controles1_menu), camera1);
  
  menuitem4 = gtk_menu_item_new_with_mnemonic (_("_Aide"));
  gtk_widget_show (menuitem4);
  gtk_container_add (GTK_CONTAINER (renderw_menubar), menuitem4);

  menu4 = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem4), menu4);

  about1 = gtk_image_menu_item_new_with_mnemonic (_("_A propos"));
  gtk_widget_show (about1);
  gtk_container_add (GTK_CONTAINER (menu4), about1);
  
  image75 = gtk_image_new_from_stock ("gtk-dialog-info", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image75);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (about1), image75);

  renderw_toolbar = gtk_toolbar_new ();
  gtk_widget_show (renderw_toolbar);
  gtk_box_pack_start (GTK_BOX (renderw_hbox), renderw_toolbar, FALSE, FALSE,
		      0);
  gtk_toolbar_set_style (GTK_TOOLBAR (renderw_toolbar), GTK_TOOLBAR_ICONS);

  renderw_newb = gtk_toolbar_insert_stock (GTK_TOOLBAR (renderw_toolbar),
					   "gtk-new",
					   NULL, NULL, NULL, NULL, -1);
  gtk_widget_show (renderw_newb);

  renderw_openb = gtk_toolbar_insert_stock (GTK_TOOLBAR (renderw_toolbar),
					    "gtk-open",
					    NULL, NULL, NULL, NULL, -1);
  gtk_widget_show (renderw_openb);

  renderw_saveb = gtk_toolbar_insert_stock (GTK_TOOLBAR (renderw_toolbar),
					    "gtk-save",
					    NULL, NULL, NULL, NULL, -1);
  gtk_widget_show (renderw_saveb);
  

  renderw_refrb = gtk_toolbar_insert_stock (GTK_TOOLBAR (renderw_toolbar),
					    "gtk-refresh",
					    NULL, NULL, NULL, NULL, -1);
  gtk_widget_show (renderw_refrb);
  
  renderw_filtersb = gtk_toolbar_insert_stock (GTK_TOOLBAR (renderw_toolbar),
					    "gtk-convert",
					    NULL, NULL, NULL, NULL, -1);
  gtk_widget_show (renderw_filtersb);
  
  gtk_widget_set_sensitive (renderw_saveb, FALSE);
  gtk_widget_set_sensitive (renderw_refrb, FALSE);
  gtk_widget_set_sensitive (renderw_filtersb, FALSE);
  gtk_widget_set_sensitive (filtres1, FALSE);
  gtk_widget_set_sensitive (enregistrer1, FALSE);
  gtk_widget_set_sensitive (enregistrer_sous1, FALSE);
  gtk_widget_set_sensitive (exporter1, FALSE);
  
  gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM(backfaceculling1), TRUE);

  drawing_area = gtk_drawing_area_new ();
  gtk_widget_set_size_request (drawing_area, 800, 600);

  gtk_widget_set_gl_capability (drawing_area,
				glconfig, NULL, TRUE, GDK_GL_RGBA_TYPE);

  gtk_box_pack_start (GTK_BOX (renderw_hbox), drawing_area, TRUE, TRUE, 0);

  renderw_statbar = gtk_statusbar_new ();
  gtk_widget_show (renderw_statbar);
  gtk_box_pack_start (GTK_BOX (renderw_hbox), renderw_statbar, FALSE, FALSE,
		      0);

  /* et on installe les callbacks pour les evenements classiques */
  /*  (voir gtkglw_cb.c) */
  gtk_widget_set_events (drawing_area,
			 GDK_EXPOSURE_MASK |
			 GDK_BUTTON_PRESS_MASK | GDK_VISIBILITY_NOTIFY_MASK);

  g_signal_connect (G_OBJECT (render_window), "destroy",
		    G_CALLBACK (on_gl_window_destroy),
		    G_OBJECT (render_window));

  g_signal_connect (G_OBJECT (drawing_area), "realize",
		    G_CALLBACK (on_gl_window_init), NULL);
  g_signal_connect (G_OBJECT (drawing_area), "configure_event",
		    G_CALLBACK (on_gl_window_reshape), NULL);
  g_signal_connect (G_OBJECT (drawing_area), "expose_event",
		    G_CALLBACK (on_gl_window_draw), NULL);
  g_signal_connect (G_OBJECT (drawing_area), "map_event",
		    G_CALLBACK (on_gl_window_map), NULL);
  g_signal_connect (G_OBJECT (drawing_area), "unmap_event",
		    G_CALLBACK (on_gl_window_unmap), NULL);
  g_signal_connect (G_OBJECT (drawing_area), "visibility_notify_event",
		    G_CALLBACK (on_gl_window_visible), NULL);

  g_signal_connect_swapped (G_OBJECT (render_window), "key_press_event",
			    G_CALLBACK (on_gl_window_key), drawing_area);

  gtk_widget_show (drawing_area);

  g_signal_connect ((gpointer) nouveau1, "activate",
		    G_CALLBACK (on_nouveau1_activate), NULL);

  g_signal_connect ((gpointer) renderw_newb, "clicked",
		    G_CALLBACK (on_renderw_newb_clicked), NULL);

  g_signal_connect ((gpointer) renderw_refrb, "clicked",
		    G_CALLBACK (on_renderw_refrb_clicked), NULL);
        
  g_signal_connect ((gpointer) quitter1, "activate",
		    G_CALLBACK (on_quitter1_activate), G_OBJECT (render_window));
        
  g_signal_connect ((gpointer) ouvrir1, "activate",
		    G_CALLBACK (on_ouvrir1_activate), NULL);
  g_signal_connect ((gpointer) enregistrer1, "activate",
		    G_CALLBACK (on_enregistrer1_activate), NULL);
  g_signal_connect ((gpointer) enregistrer_sous1, "activate",
		    G_CALLBACK (on_enregistrer_sous1_activate), NULL); 

  g_signal_connect ((gpointer) exporter1, "activate",
		    G_CALLBACK (on_exporter1_activate), NULL);

  g_signal_connect ((gpointer) renderw_openb, "clicked",
		    G_CALLBACK (on_renderw_openb_clicked), NULL);
  g_signal_connect ((gpointer) renderw_saveb, "clicked",
		    G_CALLBACK (on_renderw_saveb_clicked), NULL);
        
  g_signal_connect ((gpointer) about1, "activate",
		    G_CALLBACK (on_about1_activate), NULL); 

  g_signal_connect ((gpointer) renderw_filtersb, "clicked",
		    G_CALLBACK (on_renderw_filtersb_clicked), NULL);
        
  g_signal_connect ((gpointer) filtres1, "activate",
		    G_CALLBACK (on_filtres1_activate), NULL);
        
  g_signal_connect ((gpointer) backfaceculling1, "activate",
		    G_CALLBACK (on_backfaceculling1_activate), NULL);
  g_signal_connect ((gpointer) wireframe1, "activate",
		    G_CALLBACK (on_wireframe1_activate), NULL);      
  
  g_signal_connect ((gpointer) terrain1, "activate",
                    G_CALLBACK (on_terrain1_activate),
                    NULL);
  g_signal_connect ((gpointer) camera1, "activate",
                    G_CALLBACK (on_camera1_activate),
                    NULL);     
  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (render_window, render_window, "render_window");
  GLADE_HOOKUP_OBJECT (render_window, renderw_hbox, "renderw_hbox");
  GLADE_HOOKUP_OBJECT (render_window, renderw_menubar, "renderw_menubar");
  GLADE_HOOKUP_OBJECT (render_window, menuitem1, "menuitem1");
  GLADE_HOOKUP_OBJECT (render_window, menu1, "menu1");
  GLADE_HOOKUP_OBJECT (render_window, nouveau1, "nouveau1");
  GLADE_HOOKUP_OBJECT (render_window, ouvrir1, "ouvrir1");
  GLADE_HOOKUP_OBJECT (render_window, enregistrer1, "enregistrer1");
  GLADE_HOOKUP_OBJECT (render_window, enregistrer_sous1, "enregistrer_sous1");
   GLADE_HOOKUP_OBJECT (render_window, exporter1, "exporter1");
  GLADE_HOOKUP_OBJECT (render_window, separatormenuitem1,
		       "separatormenuitem1");
  GLADE_HOOKUP_OBJECT (render_window, quitter1, "quitter1");
  GLADE_HOOKUP_OBJECT (render_window, filtres1, "filtres1");
  GLADE_HOOKUP_OBJECT (render_window, menuitem3, "menuitem3");
  GLADE_HOOKUP_OBJECT (render_window, menu3, "menu3");
  GLADE_HOOKUP_OBJECT (render_window, menuitem4, "menuitem4");
  GLADE_HOOKUP_OBJECT (render_window, menu4, "menu4");
  GLADE_HOOKUP_OBJECT (render_window, about1, "about1");
  GLADE_HOOKUP_OBJECT (render_window, renderw_toolbar, "renderw_toolbar");
  GLADE_HOOKUP_OBJECT (render_window, renderw_newb, "renderw_newb");
  GLADE_HOOKUP_OBJECT (render_window, renderw_openb, "renderw_openb");
  GLADE_HOOKUP_OBJECT (render_window, renderw_saveb, "renderw_saveb");
  GLADE_HOOKUP_OBJECT (render_window, renderw_refrb, "renderw_refrb");
  GLADE_HOOKUP_OBJECT (render_window, renderw_filtersb, "renderw_filtersb");
  GLADE_HOOKUP_OBJECT (render_window, renderw_statbar, "renderw_statbar");

  gtk_window_add_accel_group (GTK_WINDOW (render_window), accel_group);

  return render_window;
}
